package com.ruoyi.base.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mchange.v2.beans.BeansUtils;
import com.ruoyi.base.domain.BaseCard;
import com.ruoyi.base.domain.BaseCardRights;
import com.ruoyi.base.mapper.BaseCardMapper;
import com.ruoyi.base.service.IBaseCardRightsService;
import com.ruoyi.base.service.IBaseCardService;
import com.ruoyi.base.vo.BaseCardVO;
import com.ruoyi.base.vo.CardRightsVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 会员卡Service业务层处理
 * 
 * @author vinjor-m
 * @date 2025-03-17
 */
@Service
public class BaseCardServiceImpl extends ServiceImpl<BaseCardMapper,BaseCard>  implements IBaseCardService
{
    @Autowired
    private BaseCardMapper baseCardMapper;
    @Resource
    private IBaseCardRightsService cardRightsService;

    @Override
    public IPage<BaseCard> queryListPage(BaseCard pageReqVO, Page<BaseCard> page) {
        return baseCardMapper.queryListPage(pageReqVO, page);
    }

    /**
     * 通过会员卡id查询会员及权益
     *
     * @param cardId 卡片id
     * @return com.ruoyi.base.vo.BaseCardVO
     * @author PQZ
     * @date 16:25 2025/3/26
     **/
    @Override
    public BaseCardVO queryByCardId(String cardId) {
        BaseCardVO cardVO = new BaseCardVO();
        BaseCard card = getById(cardId);
        BeanUtils.copyProperties(card,cardVO);
        List<CardRightsVO> rights = cardRightsService.queryByCardId(cardId);
        cardVO.setRights(rights);
        return cardVO;
    }
}
